#/usr/bin/perl

open (OFILE, ">ok.bzw") || die ("Can't open output file\n");
print OFILE <<EOT;
# OK Corral
#
# by His Blind Ambition
#
EOT

my $tw = 400/30.0;
my $deg = 3.14159/180;

my $storeHeight = 12;
my $saloonHeight = 16;

foreach (0..5)
{
	PrintHollowBox(-12*$tw,    (-1.5+(5*$_))*$tw,  3*$tw, 1.25*$tw, $storeHeight, 1,1);
	PrintRail((3-12)*$tw+$tw/3,(-1.5+(5*$_))*$tw, $tw/3, 1.25*$tw, $storeHeight);
}

foreach (0..4)
{
	PrintHollowBox(0,        (1.5+(5*$_))*$tw,  3*$tw, 1.25*$tw, $storeHeight, 5,5);
	PrintRail((-3)*$tw-$tw/3,(1.5+(5*$_))*$tw, $tw/3, 1.25*$tw, $storeHeight);
	PrintRail((3)*$tw+$tw/3,(1.5+(5*$_))*$tw, $tw/3, 1.25*$tw, $storeHeight);
}

foreach (0..4)
{
	PrintHollowBox((-1.5+(3*$_))*$tw,  -12*$tw,1.25*$tw, 3.0*$tw, $storeHeight, 2,2);
	PrintRail((-1.5+(3*$_))*$tw,(3-12)*$tw+$tw/3, 1.25*$tw, $tw/3, $storeHeight);
}

# saloon front
	PrintWall(-5.5*$tw, -5.5*$tw, $saloonHeight,	1, 2.75*$tw, 45,0,1);
# saloon sides
	PrintWall(-3.5*$tw, -11.0*$tw, $saloonHeight,	1, 3*$tw,   0,0,0);
	PrintWall(-11.0*$tw, -4.0*$tw, $saloonHeight,	3.5*$tw, 1, 0,0,0);
	PrintWall(-14.5*$tw, -9.5*$tw,  $saloonHeight,	1, 5*$tw, 0,0,0);
	PrintWall(-9.5*$tw, -14.5*$tw, $saloonHeight,	5*$tw, 1, 0,0,0);
# saloon roof
  PrintBox(-11*$tw, -9.25*$tw, $saloonHeight-1, 3.5*$tw, 5.25*$tw, 1, 0);
  PrintBox(-5.5*$tw, -11*$tw, $saloonHeight-1, 2*$tw, 3.5*$tw, 1, 0);
	PrintBox(-7.5*$tw, -8*$tw, $saloonHeight-1, 3*$tw, 3*$tw, 1, 45);
# saloon bar
  $barH = 4;
	PrintBox((-13.5*$tw)-.5, -9.5*$tw,  0,	.5,     4*$tw, $barH,0);
	PrintBox(-13.75*$tw,   -9.5*$tw,  $barH,	.25*$tw, 4*$tw, .5,0);

# saloon tables
  PrintBox(-10*$tw, -9*$tw,  1.5, .5*$tw, .5*$tw, .5, 45);
	  PrintBox(-10*$tw, -9*$tw,  0, .2*$tw, .2*$tw, 1.5, 45);
  PrintBox(-11*$tw, -12*$tw, 1.5, .5*$tw, .5*$tw, .5, 50);
	  PrintBox(-11*$tw, -12*$tw, 0, .2*$tw, .2*$tw, 1.5, 50);
  PrintBox(-6*$tw,  -11*$tw, 1.5, .5*$tw, .5*$tw, .5, 35);
	  PrintBox(-6*$tw,  -11*$tw, 0, .2*$tw, .2*$tw, 1.5, 35);

	MakeTeleporter(-14*$tw,-9.5*$tw, $saloonHeight, 4*$tw, 10, 0, 0); 

# hill with church	
	foreach (0..5) {
		$s = 150 - 8*$_;

		# random gravestones
		$yp = (400-$s*.1)-rand()*$s*1.6;
		$yr = 40+rand()*10;
		# regular
		PrintBox(403-$s*2, $yp, 2.5*($_+1), .85, .2, 2.6, $yr);
		$yp = (400-$s*.1)-rand()*$s*1.6;
		$yr = 40+rand()*10;
    # cross
		PrintBox(405-$s*2, $yp, 2.5*($_+1),     .2, .2, 2.8, $yr);
		PrintBox(405-$s*2, $yp, 2.5*($_+1)+2,   .7, .2, .4, $yr);

		PrintBox(400-$s,400-$s,2.5*$_, $s, $s, 2.5, 0);

		PrintBox(400-$s/2,400-$s*2.5,2.5*$_, $s/2, $s/2, 2.5, 0);
		PrintBox(400-$s*1.14,400-$s*2.14,2.5*$_, $s/2, $s*.75, 2.5, 45);
	}
# church
  PrintBox(280,280,15, 30, 15, 12, 45);

	MakeTeleporter(280,280, 15+12+5, $tw, 10, 45, 0); 

  PrintBox(260,260,15,  8,  8, 12+12, 45);
  PrintPyramid(260,260,15+12+12+.01,8,8,12, 45);

  PrintFence(-13*$tw,-20*$tw,.125,9*$tw, 45);
  PrintFence(-7*$tw,-28.75*$tw,.125,2.5*$tw, 0);
  PrintFence(-19*$tw,-8*$tw,.125,6*$tw, 0);
  PrintFence(-25*$tw,-2*$tw,6*$tw,.125, 0);

MakeLink(0,2);
MakeLink(1,3);
MakeLink(2,1);
MakeLink(3,0);

close OFILE;
exit;

sub PrintFence()
{
	my ($x, $y, $xr, $yr, $r) = @_;
	my $tall  = 1.0;
	my $ptall = 3.5;

	PrintBox($x,$y,0.75,$xr,$yr,$tall,$r);
	PrintBox($x,$y,2.25,$xr,$yr,$tall,$r);

	PrintBox($x,$y,0,.4,.4,$ptall,$r+45);
	if ($r == 0) {
		if ($xr > $yr) {
			PrintBox($x+$xr*.5,$y,0,.25,.25,$ptall,$r+45);
			PrintBox($x-$xr*.5,$y,0,.25,.25,$ptall,$r+45);
			PrintBox($x+$xr*1,$y,0,.25,.25,$ptall,$r+45);
			PrintBox($x-$xr*1,$y,0,.25,.25,$ptall,$r+45);
		}
		else {
			PrintBox($x,$y+$yr*.5,0,.25,.25,$ptall,$r+45);
			PrintBox($x,$y-$yr*.5,0,.25,.25,$ptall,$r+45);
			PrintBox($x,$y+$yr*1,0,.25,.25,$ptall,$r+45);
			PrintBox($x,$y-$yr*1,0,.25,.25,$ptall,$r+45);
		}
	}
	else {
			PrintBox($x-$yr*.5,$y+$yr*.5,0,.25,.25,$ptall,$r+45);
			PrintBox($x+$yr*.5,$y-$yr*.5,0,.25,.25,$ptall,$r+45);
	}
}

sub PrintRail()
{
	my ($x, $y, $xr, $yr, $tall) = @_;
	PrintBox($x,$y,$tall-0.5, $xr,$yr,0.5,0);
	if ($xr > $yr) {
		PrintBox($x-$xr*.66,$y,0, .2,.2,$tall-0.5,0);
		PrintBox($x+$xr*.66,$y,0, .2,.2,$tall-0.5,0);
	}
	else {
		PrintBox($x,$y+$yr*.66,0, .2,.2,$tall-0.5,0);
		PrintBox($x,$y-$yr*.66,0, .2,.2,$tall-0.5,0);
	}
}

sub PrintHollowBox()
{
	my ($x, $y, $xr, $yr, $tall,$d,$fac) = @_;
	# walls and facades
	PrintWall($x+$xr-.5,$y,$tall,	1,$yr, 0,($d & 1), ($fac & 1));
	PrintWall($x,$y+$yr-.5,$tall,	$xr,1, 0,($d & 2), ($fac & 2));
	PrintWall($x+.5-$xr,$y,$tall,	1,$yr, 0,($d & 4), ($fac & 4));
	PrintWall($x,$y+.5-$yr,$tall,	$xr,1, 0,($d & 8), ($fac & 8));
	# ceil
	PrintBox($x,$y,$tall-2,$xr,$yr,2,0);
}

sub PrintWall($$$$$$)
{
	my ($x,$y,$tall,$w,$h,$r,$d,$f) = @_;
	if ($d) {
		if ($w > $h) {
			PrintBox($x-$w*.625,$y,0, $w*.375,$h,$tall/2,$r);
			PrintBox($x+$w*.625,$y,0, $w*.375,$h,$tall/2,$r);
		}
		else {
			PrintBox($x,$y-$h*.625,0, $w,$h*.375,$tall/2,$r);
			PrintBox($x,$y+$h*.625,0, $w,$h*.375,$tall/2,$r);
		}
		PrintBox($x,$y,$tall/2, $w,$h,$tall/2,$r);
	}
	else {
		PrintBox($x,$y,0, $w,$h,$tall,$r);
	}
	
	PrintFacade($x,$y,$tall,$w,$h,$r,$f);
}

sub PrintFacade($$$$$$)
{
	my ($x,$y,$tall,$w,$h,$r,$frontstyle) = @_;
	my $fh = 1.5;
	my $fp = 8;
	PrintBox($x,$y,$tall,	$w,$h,$fh, $r);
	PrintBox($x,$y,$tall+$fh+.2,	$w,$h,$fp, $r) if $frontstyle;
	# PrintPyramid($x,$y,$tall+$fh+.2+$fp,	$w,$h,$fp, $r);
}

sub PrintBox($$$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs,$r) = @_;
	printf OFILE "box\n";
	printf OFILE "position %7.3f %7.3f %7.3f\n",$x,$y,$z;
	printf OFILE "rotation %7.3f\n",$r;
	printf OFILE "size %7.3f %7.3f %7.3f\n",$xs,$ys,$zs;
	printf OFILE "end\n\n";
}

sub PrintPyramid($$$$$$)
{
	my ($x,$y,$z,$xs,$ys,$zs, $r) = @_;

	printf OFILE "pyramid\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize %6.3f %6.3f %6.3f\nend\n\n",
							$x,$y,$z,$r,$xs,$ys,$zs;
}

sub MakeTeleporter($$$$$$)
{
	my ($x,$y,$z,$w,$h,$rot,$b) = @_;
	printf OFILE "teleporter\nposition %6.3f %6.3f %6.3f\nrotation %6.3f\nsize 0 %6.3f %6.3f\nborder %d\nend\n\n",
							$x,$y,$z,$rot,$w,$h,$b;
}

sub MakeLink($$)
{
	my ($from,$to) = @_;
	print OFILE <<EOT;
link
from $from
to   $to
end
EOT
}
